/*
 *  FeatureMap.java
 *
 *  Copyright (c) 1998-2001, The University of Sheffield.
 *
 *  This file is part of GATE (see http://gate.ac.uk/), and is free
 *  software, licenced under the GNU Library General Public License,
 *  Version 2, June 1991 (in the distribution as file licence.html,
 *  and also available at http://gate.ac.uk/gate/licence.html).
 *
 *  Hamish Cunningham, Jan/19/2000
 *
 *  $Id: FeatureMap.java,v 1.4 2000/12/08 10:31:35 cursu Exp $
 */

package gate;
import java.util.*;
import gate.util.*;

/** An attribute-value matrix. Represents the content of an annotation, the
  * meta-data on a resource, and anything else we feel like.
  */
public interface FeatureMap extends Map
{
  /** Test if <b>this</b> featureMap object is included in aFeatureMap
    * @param aFeatureMap object which will incude or not this FeatureMap obj.
    * @return <code>true</code> if <b>this</b> is incuded in aFeatureMap
    * and <code>false</code> if not.
    */
  public boolean subsumes(FeatureMap aFeatureMap);

} // interface FeatureMap
