/*
 *  Table.java
 *
 *  Copyright (c) 1998-2001, The University of Sheffield.
 *
 *  This file is part of GATE (see http://gate.ac.uk/), and is free
 *  software, licenced under the GNU Library General Public License,
 *  Version 2, June 1991 (in the distribution as file licence.html,
 *  and also available at http://gate.ac.uk/gate/licence.html).
 * 
 *  Valentin Tablan, 06/03/2000
 *
 *  $Id: Table.java,v 1.6 2000/11/08 16:34:56 hamish Exp $
 */

package gate.db;

/**
  * This class is used in defining databases structure.
  * More precisely this class defines a database Table.
  */
public class Table{

  /** Debug flag */
  private static final boolean DEBUG = false;

  /** Constructor.
    *
    * @param name The name of the Table.
    * @param fields an array of gaet.db.Field values describing the columns
    * of this table.
    * @param statements an array of String values, representing any SQL
    * statements that need to be run when initializing this table.
    */
  public Table(String name, Field[] fields, String[] statements){
    this.name = name;
    this.fields = fields;
    this.statements = statements;
  }

  public String name;

  public Field[] fields;

  public String[] statements;

} // Table
