/*
 *  ProgressListener.java
 *
 *  Copyright (c) 1998-2001, The University of Sheffield.
 *
 *  This file is part of GATE (see http://gate.ac.uk/), and is free
 *  software, licenced under the GNU Library General Public License,
 *  Version 2, June 1991 (in the distribution as file licence.html,
 *  and also available at http://gate.ac.uk/gate/licence.html).
 *
 *  Valentin Tablan, 03/07/2000
 *
 *  $Id: ProgressListener.java,v 1.1 2001/03/06 15:01:13 valyt Exp $
 */

package gate.event;

import java.util.*;

/** This interface describes objects that can register themselves as listeners
 * to ProcessProgressReporters.
 * They need to be able to handle progress change and process finished events.
 *
 */
public interface ProgressListener extends EventListener{

  /**
   * Called when the progress has changed
   *
   * @param i
   */
  public void progressChanged(int i);

  /**
   * Called when the process is finished.
   *
   */
  public void processFinished();

} // ProgressListener

